//+------------------------------------------------------------------+
//|                                                    Gomez EMP.mq4 |
//|                   Copyright  2010, Gomez Financial Engine, CEO. |
//|                                          fxprogrammer@rambler.ru |
//+------------------------------------------------------------------+
#property copyright "Gomez Financial Engine, CEO"
#property link      "fxprogrammer@rambler.ru"
//----
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DarkOrange
//---- input parameters
extern int BandPeriod = 20;
//---- buffers
double BandBuffer[];
double UpSwingBuffer[];
double LowSwingBuffer[];
double DevBuffer[];
double LnBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 4 additional buffers are used for counting.
   IndicatorBuffers(5);
   
   SetIndexBuffer(1, UpSwingBuffer);
   SetIndexBuffer(2, DevBuffer);
   SetIndexBuffer(3, LnBuffer);
   SetIndexBuffer(4, LowSwingBuffer);

   
//---- indicator lines
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, BandBuffer);

//----
   if(BandPeriod <= 0)
       BandPeriod = 20;
//----
   SetIndexDrawBegin(0, BandPeriod);
  
//---- name for DataWindow and indicator subwindow label
   short_name="Gomez Band(" + BandPeriod + ")";
   IndicatorShortName(short_name);
   SetIndexLabel(0, short_name);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Commodity Channel Index                                          |
//+------------------------------------------------------------------+
int start() {
   int i, k, counted_bars = IndicatorCounted();
   double sum = 0;
   double av_sum = 0; 
   
   if(BandPeriod <= 1) return(0);

   int limit1 = Bars - counted_bars;
   int limit2=limit1;
   if (limit1>1) {
      limit1=Bars-2;
      limit2=Bars-BandPeriod-2;
   }


//---- natural log
   for (i = limit1;i>=0;i--) LnBuffer[i] = (Close[i]/Close[i+1]);
   for (i = limit2;i>=0;i--) {
      DevBuffer[i]=iStdDevOnArray(LnBuffer, 0, BandPeriod, 0, MODE_SMA,i);
      double tmp=Close[i]/iMA(NULL, 0, BandPeriod, 0, MODE_SMA, PRICE_CLOSE, i);
      UpSwingBuffer[i] = (1.0-DevBuffer[i])*tmp;
      LowSwingBuffer[i] = (1.0-DevBuffer[i])/tmp;
      BandBuffer[i] = UpSwingBuffer[i] - LowSwingBuffer[i];
   }
   return(0);
  }
//+------------------------------------------------------------------+